package com.elephant.framework.galaxy.aroad.module.zhyh.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import com.elephant.framework.galaxy.aroad.module.zhyh.entity.ZhglScfj;
import com.elephant.framework.galaxy.aroad.module.zhyh.service.ZhglScfjService;
import com.elephant.framework.galaxy.aroad.security.entity.GalaxyUser;
import com.elephant.framework.galaxy.aroad.util.SecurityUtils;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.UUID;


/**
 * 智慧公路_上传附件表
 *
 * @author wangjian
 * @date 2019-05-06 20:16:42
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhyh/scfj")
public class ZhglScfjController extends BaseController  {

  private final  ZhglScfjService zhglScfjService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhglScfj 智慧公路_上传附件表
   * @return
   */
  @GetMapping("/page")
  public R getZhglScfjPage(Page page, ZhglScfj zhglScfj) {
    return  new R<>(zhglScfjService.getZhglScfjPage(page,zhglScfj));
  }


  /**
   * 通过id查询智慧公路_上传附件表
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") String id){
    return new R<>(zhglScfjService.getById(id));
  }

  /**
   * 新增智慧公路_上传附件表
   * @param zhglScfj 智慧公路_上传附件表
   * @return R
   */
  @SysLog("新增智慧公路_上传附件表")
  @PostMapping
  public R save(@RequestBody ZhglScfj zhglScfj){
    String uuid = UUID.randomUUID().toString().replaceAll("-","");
    GalaxyUser galaxyUser = SecurityUtils.getUser();

    zhglScfj.setId(uuid);
    zhglScfj.setScr(galaxyUser.getUsername());
    zhglScfj.setWjzt("已上传");
    zhglScfj.setScsj((new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss")).format(new Date()));
    return new R<>(zhglScfjService.save(zhglScfj));
  }

  /**
   * 修改智慧公路_上传附件表
   * @param zhglScfj 智慧公路_上传附件表
   * @return R
   */
  @SysLog("修改智慧公路_上传附件表")
  @PutMapping
  public R updateById(@RequestBody ZhglScfj zhglScfj){
    return new R<>(zhglScfjService.updateById(zhglScfj));
  }

  /**
   * 通过id删除智慧公路_上传附件表
   * @param id id
   * @return R
   */
  @SysLog("删除智慧公路_上传附件表")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable String id){
    return new R<>(zhglScfjService.removeById(id));
  }

}
